/* FileUtility.java */

import java.io.*;

public class FileUtility {

    /**
     * Warning: source and destination must be opened and closed by the caller
     *
     */
    static protected void byte_file_transfer(DataInputStream src, DataOutputStream dest) throws IOException {

        // loop: read from source and write to dest
        int buffer;
        try {
            // break from cycle if we read a negative value -> EOF
            // Note: this function consumes EOF
            while ((buffer = src.read()) >= 0) {
                dest.write(buffer);
            }
            dest.flush();
        } catch (EOFException e) {
            System.out.println("Error: ");
            e.printStackTrace();
        }
    }

    /**
     * Warning: source and destination must be opened and closed by the caller
     *
     */
    static protected void n_byte_file_transfer(DataInputStream src, DataOutputStream dest, long nbytes) throws IOException {

        int cont = 0;
        // loop: read from source and write to dest
        int buffer = 0;
        try {
            // esco dal ciclo quando ho letto il numero di byte da trasferire
            while (cont < nbytes) {
                buffer = src.read();
                dest.write(buffer);
                cont++;
            }
            dest.flush();
            System.out.println("Transferred bytes: " + cont);
        } catch (EOFException e) {
            System.out.println("Error: ");
            e.printStackTrace();
        }
    }
}
